#include <jabber.h>

mreturn mod_auth_plain_offline(mapi m, void *arg)
{
    char *passA, passB;

    if(m->variant != MAPI_VARAUTH) return IGNORE;

    log_debug("mod_auth_plain","checking");

    passA = xmlnode_get_tag_data(m->packet->iq, "password");
    passB = xmlnode_get_tag_data(xdb_get(m->user, NS_AUTH));

    if(passA == NULL || passB == NULL) return PASS;

    if(strcmp(passA, passB) != 0)
        js_error(m->packet->x, TERROR_AUTH, "Authentication Failed");
    else
        js_iqreply(m->packet->x);

    return HANDLED;
}

void mod_auth_plain(void)
{
    log_debug("mod_auth_plain","init");
    js_mapi_register(offline, mod_auth_plain_offline, NULL);
}
